import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;
import static org.junit.jupiter.api.Assertions.*;

    class FractionTestParam {
        @ParameterizedTest
        @CsvSource({
                "1, 2, 1, 4, 3, 4",
                "1, 3, 2, 3, 1, 1",
                "2, 5, 3, 5, 1, 1",
                "-1, 2, 1, 6, -1, 3"
        })
        void testAdd(int num1, int den1, int num2, int den2, int expectedNum, int expectedDen) {
            Fraction fraction1 = new Fraction(num1, den1);
            Fraction fraction2 = new Fraction(num2, den2);
            fraction1.add(fraction2);

            Fraction expectedFraction = new Fraction(expectedNum, expectedDen);
            assertEquals(expectedFraction, fraction1);
        }
    }


