import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.MethodSource;

import java.util.stream.Stream;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class ParamCelebrityProblemTest {
    private CelebrityProblem cp;

    public static class TestData {
        public final int[][] matrix;
        public final int n;
        public final int expectedCelebrity;

        public TestData(int[][] matrix, int n, int expectedCelebrity) {
            this.matrix = matrix;
            this.n = n;
            this.expectedCelebrity = expectedCelebrity;
        }
    }

    public static Stream<TestData> testDataProvider() {
        return Stream.of(
                new TestData(new int[][]{
                        {0, 1, 1, 0},
                        {0, 0, 1, 0},
                        {0, 0, 0, 0},
                        {0, 1, 1, 0}
                }, 4, 2),
                new TestData(new int[][]{
                        {0, 1, 1},
                        {0, 0, 1},
                        {0, 0, 0}
                }, 3, 2),
                new TestData(new int[][]{
                        {0, 1},
                        {0, 0}
                }, 2, 1),
                new TestData(new int[][]{
                        {0}
                }, 1, 0)
        );
    }

    @BeforeEach
    public void setup() {
    }

    @ParameterizedTest
    @MethodSource("testDataProvider")
    public void testFindCelebrity(TestData testData) {
        cp = new CelebrityProblem(testData.matrix);
        int celebrity = cp.findCelebrity(testData.n);
        assertEquals(testData.expectedCelebrity, celebrity);
    }
}
